ConvertFloat4DF    proto   :DWORD, :DWORD
ConvertFloat4DR    proto   :DWORD, :DWORD
ConvertFloat4BX    proto   :DWORD, :DWORD
ConvertFloat4BF    proto   :DWORD, :DWORD
ConvertFloat4CT    proto   :DWORD, :DWORD
ConvertFloat4BY    proto   :DWORD, :DWORD
ConvertFloat4DY    proto   :DWORD, :DWORD
ConvertFloat4DX    proto   :DWORD, :DWORD
ConvertFloat4DS    proto   :DWORD, :DWORD
ConvertFloat4BW    proto   :DWORD, :DWORD
ConvertFloat4DW    proto   :DWORD, :DWORD
ConvertFloat4DZ    proto   :DWORD, :DWORD
; 
.code
; 
; Input:
;           pReal4 = pointer                               dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
ConvertFloat4DF     proc     pReal4:DWORD, pRcl:DWORD
                    LOCAL    expscale     :DWORD
                    LOCAL    exponent     :DWORD
                    LOCAL    DWinteger    :DWORD
                    LOCAL    oldcw        :WORD
                    LOCAL    truncw       :WORD
                    LOCAL    string[22]   :BYTE
                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      edi, pRcl     
                    mov      ebx, pReal4

                    ; --------------------------
                    ;          examine
                    ; --------------------------
                    EXAMINE1REAL4
                                                                  
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG1BASE10_X
                    ; -----------------------------------------------------------
                    ;       Convert the logarithm to a truncated integer
                    ; store the truncating value of the logarithm and doesnt POP
                    ; -----------------------------------------------------------      
                    SETTRUNCATE oldcw, truncw
                    fistp    exponent
                    fldcw    oldcw          ; load back the former control word

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, exponent
                    mov     expscale, edx
           
                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
            
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    expscale
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   DWinteger
                    fstsw   ax
                    fwait
                    shr     ax,1              ;test for invalid operation
                    jc      _erro2S  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, DWinteger
                    mov     eax, dword ptr [esi+0]

                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                                        
            @@:     lea     esi, string+20

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in BL
                    ; ----------------------------------------
                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    mov     eax, ebx
                    sub     eax, expscale
                    sub     eax, 1
                    ;mov     exponent, eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; eax = exponent
                    ; ------------------------------------------
                
                    or      eax, eax
                    jns     short _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

            ;--------------------------------------------------
            ; ebx = total number of digits
            ; edx = number of decimal places
            ; eax = exponent
            ;--------------------------------------------------
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                    ;jmp     _isscientific
                                   
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;--------------------------------------------------
    _isscientific:  sub     ebx, 1
                    
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                            
        _finish:    mov      eax, edi
                    mov      edi, pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret
;-----------------------------------------------------------
    _isinfinityS:   mov      byte ptr [edi], al     
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    mov      eax, 9
                    jmp      _exit0
                   
                    ;--------------------------
                    ; value to be converted = 0
                    ;--------------------------
        _iszeroS:   mov      word ptr [edi], 3020h
                    mov      eax, 2
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1S:    mov      eax, 1
                    ; -------------------
                    ; Remove sign / space
                    ; -------------------
        _errorS:    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2S:    sub      edi, 1
                    fclex
                    mov      eax, 2
                    jmp      _errorS
ConvertFloat4DF     endp
; 
; 
; Input:
;           pReal4 = pointer                                dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
ConvertFloat4DR     proc     pReal4:DWORD, pRcl:DWORD
                    LOCAL    expscale     :DWORD
                    LOCAL    exponent     :DWORD
                    LOCAL    DWinteger    :DWORD
                    LOCAL    oldcw        :WORD
                    LOCAL    truncw       :WORD
                    LOCAL    string[22]   :BYTE
                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      edi, pRcl     
                    mov      ebx, pReal4                    

                    ; --------------------------
                    ;          examine
                    ; --------------------------
                    EXAMINE1REAL4
                                                                  
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATE  oldcw, truncw                    
                    fistp    exponent           
                    fldcw    oldcw

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, exponent
                    mov     expscale, edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    expscale
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul
                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   DWinteger
                    fstsw   ax
                    fwait
                    shr     ax,1
                    jc      _erro2S  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, DWinteger
                    mov     eax, dword ptr [esi+0]

                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    
            @@:     lea     esi, string+20

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in CL
                    ; ----------------------------------------
                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    ; --------------------------
                    ;   Correct the exponent
                    ; --------------------------
                    mov     eax, ebx
                    sub     eax, expscale
                    sub     eax, 1
                    ;mov     exponent, eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; ecx = exponent
                    ; ------------------------------------------
                    or      eax, eax
                    jns     _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
;-----------------------------------------------------                                        
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;
            ; ebx = total number of digits
            ; eax = exponent
            ;--------------------------------------------------
    _isscientific:  sub     ebx,1
                    ;
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                                        
        _finish:    mov      eax, edi
                    mov      edi, pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret
;-----------------------------------------------------------
    _isinfinityS:   mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    mov      eax, 9
                    jmp      _exit0
                   
                    ;--------------------------
                    ; value to be converted = 0
                    ;--------------------------
        _iszeroS:   mov      word ptr [edi], 3020h
                    mov      eax, 2
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1S:    mov      eax, 1
                    ; -------------------
                    ; 
                    ; -------------------
        _errorS:    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2S:    sub      edi, 1
                    fclex
                    mov      eax, 2
                    jmp      _errorS
ConvertFloat4DR     endp
; 
comment * -----------------------------------------------------------------
          . ConvertFloat4BX
          . Doesnt preserve the FPU registers          
          . Preserves registers EBX, ESI and EDI          
          . Updated March 2013
          ---------------------------------------------------------------- *
; 
ConvertFloat4BX     proc     pReal4:DWORD, pRcl:DWORD 
                    LOCAL    unpacked[22]     :BYTE
                    LOCAL    expscale         :DWORD
                    LOCAL    exponent         :DWORD
                    LOCAL    decimal          :DWORD
                    LOCAL    oldcw            :WORD
                    LOCAL    truncw           :WORD
                    LOCAL    bcdstr[10]       :BYTE
                                      
                    push     ebx
                    push     esi
                    push     edi

                    mov      ebx, pReal4                    
                    mov      edi, pRcl
                          
                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------      
        _start:     
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG2BASE10_X                                        
                    SETTRUNCATE oldcw, truncw
                    fistp    exponent
                    fldcw    word ptr oldcw

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, exponent
                    mov     expscale, edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;              compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    expscale
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ;-------------------------------------------------------------
                    ; fbstp rounds the value in ST(0) to the nearest integer 
                    ;-------------------------------------------------------------
                    fbstp    tbyte ptr bcdstr
                    fstsw    ax
                    fwait
                    shr      ax,1
                    jc       _erro2  

                    ;--------------------------------------------
                    ; unpack BCD format from 10 bytes to 20 bytes
                    ;    the 10 bytes in bcdstr first is sign
                    ;   Go from byte position 9 to position 0 
                    ;      position ecx=8 is digits d17,d16
                    ;       position ecx=0 is digits d1,d0
                    ;--------------------------------------------

                    UNPACKBCDSTRING
                    
                    ; -------------------------------
                    ;   ebx= first digit position
                    ; -------------------------------
                    mov     eax, exponent

                    mov     edx, $DECIMALPLACES_REAL4
                    mov     ebx, 19                     ; 19=offset 20 minus 1
                    sub     ebx, edx
          
                    cmp     byte ptr [esi+ebx], '0'
                    jne     short @F

                    add     ebx, 1              ; next position
                    sub     eax, 1              ; exponent=exponent-1
                    
                    ; -----------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; edx= number of decimal places                    
                    ; -----------------------------------
            @@:     mov     ecx, 20
                    sub     ecx, ebx     

                    mov     edx, expscale
                    add     edx, eax

                    or      eax, eax
                    jns     _ispositive
                    ;
                    mov     ecx, eax                    
                    neg     ecx
                    cmp     ecx, edx
                    jae     _isscientific
                    
                ; 
                ;  Regular notation - negative
                ; 
                    mov     ax, '.0'
                    mov     word ptr [edi], ax
                    add     edi, 2
                    ;
                    sub     ecx, 1
                    jz      short _movedecimal
                    ;
                    sub     edx, ecx
                    ;
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                                        
                    ; -----------------------------
                    ;     edx decimal digits
                    ; -----------------------------
    _movedecimal:   movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;--------------------------------------------------------------------
    _ispositive:    cmp     eax, edx
                    ja      _isscientific
                    
                ; 
                ;  Regular notation - positive
                ; 
                    add     eax, 1              ; number of integer digits
                    sub     ecx, eax            ; number of decimal digits                

            @@:     movzx   edx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], dl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     eax, 1
                    jnz     short @B

                    or      ecx, ecx
                    jz      _finish
                                        
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;                    
            @@:     movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                    jz      short _removeI
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;...........................................................................                   
                ; 
                ;    Scientific Notation    
                ; 

                    ; -------------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; is >= edx decimal places
                    ; -------------------------------------
    _isscientific:  movzx   ecx, byte ptr [esi+ebx]
                    add     ebx, 1
                    mov     ch, '.'
                    mov     word ptr [edi], cx
                    add     edi, 2
                    ;
                    ; move 
                    ;                   
            @@:     movzx   ecx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], cl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short @B 
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B
                   
            ;........................................
            @@:     EXPONENTREAL_4R                   

        _finish:    mov      eax, edi
                    mov      edi, pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret
;------------------------------------------------------------
;                      fxam, ebp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0

        _erro1:     fstp     st(0)
                    mov      eax, 1
                    
        _error:     mov      dword ptr [edi], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    mov      byte ptr [edi+5], 0
                    mov      dword ptr [edi-4], 5
                    stc
                    jmp      _exit
                    
        _erro2:     fclex
                    mov      eax, 2
                    jmp     _error
ConvertFloat4BX     endp
; 
comment * -----------------------------------------------------------------
          . ConvertFloat4BF
          . Doesnt preserve the FPU registers          
          . Preserves registers EBX, ESI and EDI          
          . Updated March 2013
          ---------------------------------------------------------------- *
; 
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4BF     proc     pReal4:DWORD, pRcl:DWORD                                      
                    push     ebx
                    push     esi
                    push     edi

                    mov      ebx, [esp+16]      ;pReal4                    
                    mov      edi, [esp+20]      ;pRcl
                    sub      esp, stk_lenR4                    
                    mov      [esp+stk_pStrR4], edi

                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------      
        _start:     
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATER4
                    fistp    dword ptr [esp+stk_exponentR4]
                    fldcw    word ptr [esp+stk_oldcwR4]

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk_exponentR4]
                    mov     [esp+stk_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ;-------------------------------------------------------------
                    ; fbstp rounds the value in ST(0) to the nearest integer 
                    ;-------------------------------------------------------------
                    fbstp    tbyte ptr [esp+stk_bcdstrR4]
                    fstsw    ax
                    fwait
                    shr      ax,1
                    jc       _erro2  

                    ;--------------------------------------------
                    ; unpack BCD format from 10 bytes to 20 bytes
                    ;    the 10 bytes in bcdstr first is sign
                    ;   Go from byte position 9 to position 0 
                    ;      position ecx=8 is digits d17,d16
                    ;       position ecx=0 is digits d1,d0
                    ;--------------------------------------------

                    UNPACKBCDSTRR4

                    ; -------------------------------
                    ;   ebx= first digit position
                    ; -------------------------------
                    mov     eax, [esp+stk_exponentR4]

                    mov     edx, $DECIMALPLACES_REAL4
                    mov     ebx, 19                     ; 19=offset 20 minus 1
                    sub     ebx, edx
          
                    cmp     byte ptr [esi+ebx], '0'
                    jne     short @F

                    add     ebx, 1              ; next position
                    sub     eax, 1              ; exponent=exponent-1
                    
                    ; -----------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; edx= number of decimal places
                    ; -----------------------------------
            @@:     mov     ecx, 20
                    sub     ecx, ebx     

                    mov     edx, [esp+stk_expscaleR4]
                    add     edx, eax

                    or      eax, eax
                    jns     _ispositive
                    ;
                    mov     ecx, eax                    
                    neg     ecx
                    cmp     ecx, edx
                    jae     _isscientific
                    
                ; 
                ;  Regular notation - negative
                ; 
                    mov     ax, '.0'
                    mov     word ptr [edi], ax
                    add     edi, 2
                    ;
                    sub     ecx, 1
                    jz      short _movedecimal
                    ;
                    sub     edx, ecx
                    ;
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                                        
                    ; -----------------------------
                    ;     edx decimal digits
                    ; -----------------------------
    _movedecimal:   movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;--------------------------------------------------------------------
    _ispositive:    cmp     eax, edx
                    ja      _isscientific
                    
                ; 
                ;  Regular notation - positive
                ; 
                    add     eax, 1              ; number of integer digits
                    sub     ecx, eax            ; number of decimal digits

            @@:     movzx   edx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], dl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     eax, 1
                    jnz     short @B

                    or      ecx, ecx
                    jz      _finish
                                        
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;                    
            @@:     movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                    jz      short _removeI
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;...........................................................................                   
                ; 
                ;    Scientific Notation    
                ; 

                    ; -------------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; is >= edx decimal places
                    ; -------------------------------------
    _isscientific:  movzx   ecx, byte ptr [esi+ebx]
                    add     ebx, 1
                    mov     ch, '.'
                    mov     word ptr [edi], cx
                    add     edi, 2
                    ;
                    ; move 
                    ;                   
            @@:     movzx   ecx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], cl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short @B 
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B
                   
            ;........................................
            @@:     EXPONENTREAL_4R                   

        _finish:    mov      eax, edi
                    mov      edi, [esp+stk_pStrR4]        ; pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8
;------------------------------------------------------------
;                      fxam, esp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0

        _erro1:     fstp     st(0)
                    mov      eax, 1
                    
        _error:     add      esp, stk_lenR4
        
                    mov      dword ptr [edi], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    mov      byte ptr [edi+5], 0
                    mov      dword ptr [edi-4], 5                    
                    stc 
                    jmp      _exit

        _erro2:     fclex
                    mov      eax, 2
                    jmp     _error
ConvertFloat4BF     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef
comment * -----------------------------------------------------------------
          . ConvertFloat4CF
          . Doesnt preserve the FPU registers          
          . Preserves registers EBX, ESI and EDI          
          . Updated March 2013
          ---------------------------------------------------------------- *
; 
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4CT     proc     pReal4:DWORD, pRcl:DWORD                                      
                    push     ebx
                    push     esi
                    push     edi

                    mov      ebx, [esp+16]      ;pReal4                    
                    mov      edi, [esp+20]      ;pRcl
                    sub      esp, stk_lenR4
                    
                    mov      [esp+stk_pStrR4], edi

                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------      
        _start:     
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATER4
                    fistp    dword ptr [esp+stk_exponentR4]
                    fldcw    word ptr [esp+stk_oldcwR4]

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk_exponentR4]
                    mov     [esp+stk_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale                    

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]
        
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ;-------------------------------------------------------------
                    ; fbstp rounds the value in ST(0) to the nearest integer 
                    ;-------------------------------------------------------------
                    fbstp    tbyte ptr [esp+stk_bcdstrR4]
                    fstsw    ax
                    fwait
                    shr      ax,1
                    jc       _erro2  

                    ;--------------------------------------------
                    ; unpack BCD format from 10 bytes to 20 bytes
                    ;    the 10 bytes in bcdstr first is sign
                    ;   Go from byte position 9 to position 0 
                    ;      position ecx=8 is digits d17,d16
                    ;       position ecx=0 is digits d1,d0
                    ;--------------------------------------------
                    
                    UNPACKBCDSTRR4CT
                    
                    ; -------------------------------
                    ;   ebx= first digit position
                    ; -------------------------------
                    mov     eax, [esp+stk_exponentR4]

                    mov     edx, $DECIMALPLACES_REAL4
                    mov     ebx, 19                     ; 19=offset 20 minus 1
                    sub     ebx, edx
          
                    cmp     byte ptr [esi+ebx], '0'
                    jne     short @F

                    add     ebx, 1              ; next position
                    sub     eax, 1              ; exponent=exponent-1
                    
                    ; -----------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; edx= number of decimal places
                    ; -----------------------------------
            @@:     mov     ecx, 20
                    sub     ecx, ebx     

                    mov     edx, [esp+stk_expscaleR4]
                    add     edx, eax

                    or      eax, eax
                    jns     _ispositive
                    ;
                    mov     ecx, eax                    
                    neg     ecx
                    cmp     ecx, edx
                    jae     _isscientific
                    
                ; 
                ;  Regular notation - negative
                ; 
                    mov     ax, '.0'
                    mov     word ptr [edi], ax
                    add     edi, 2
                    ;
                    sub     ecx, 1
                    jz      short _movedecimal
                    ;
                    sub     edx, ecx
                    ;
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                                        
                    ; -----------------------------
                    ;     edx decimal digits
                    ; -----------------------------
    _movedecimal:   movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;--------------------------------------------------------------------
    _ispositive:    cmp     eax, edx
                    ja      _isscientific
                    
                ; 
                ;  Regular notation - positive
                ; 
                    add     eax, 1              ; number of integer digits
                    sub     ecx, eax            ; number of decimal digits

            @@:     movzx   edx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], dl
                    add     ebx, 1
                    add     edi, 1

                    sub     eax, 1
                    jnz     short @B

                    or      ecx, ecx
                    jz      _finish
                                        
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;                    
            @@:     movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                    jz      short _removeI
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;...........................................................................                   
                ; 
                ;    Scientific Notation    
                ; 

                    ; -------------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; is >= edx decimal places
                    ; -------------------------------------
    _isscientific:  movzx   ecx, byte ptr [esi+ebx]
                    add     ebx, 1
                    mov     ch, '.'
                    mov     word ptr [edi], cx
                    add     edi, 2
                    ;
                    ; move 
                    ;                   
            @@:     movzx   ecx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], cl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short @B 
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B
                   
            ;........................................
            @@:     EXPONENTREAL_4R                   

        _finish:    mov      eax, edi
                    mov      edi, [esp+stk_pStrR4]        ; pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8
;------------------------------------------------------------
;                      fxam, esp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0

        _erro1:     fstp     st(0)
                    mov      eax, 1
                    
        _error:     add      esp, stk_lenR4
        
                    mov      dword ptr [edi], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    mov      byte ptr [edi+5], 0
                    mov      dword ptr [edi-4], 5                    
                    stc 
                    jmp      _exit

        _erro2:     fclex
                    mov      eax, 2
                    jmp     _error
ConvertFloat4CT     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef  
;                 
comment * -----------------------------------------------------------------
          . ConvertFloat4BY
          . Doesnt preserve the FPU registers          
          . Preserves registers EBX, ESI and EDI          
          . Updated March 2013
          ---------------------------------------------------------------- *
; 
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4BY     proc     pReal4:DWORD, pRcl:DWORD                                      
                    push     ebx
                    push     esi
                    push     edi

                    mov      ebx, [esp+16]      ;pReal4                    
                    mov      edi, [esp+20]      ;pRcl
                    sub      esp, stk_lenR4
                    
                    mov      [esp+stk_pStrR4], edi

                    ; --------------------------
                    ;          examine
                    ; --------------------------
                    EXAMINE1SREAL4
                                  
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------      
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATER4
                    fistp    dword ptr [esp+stk_exponentR4]
                    fldcw    word ptr [esp+stk_oldcwR4]

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk_exponentR4]
                    mov     [esp+stk_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ; compute 10^expscale= 10^expscaleM * 10^expscaleS
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                  
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ;-------------------------------------------------------------
                    ; fbstp rounds the value in ST(0) to the nearest integer 
                    ;-------------------------------------------------------------
                    fbstp    tbyte ptr [esp+stk_bcdstrR4]
                    fstsw    ax
                    fwait
                    shr      ax,1
                    jc       _erro2S 
                     
                    ;--------------------------------------------
                    ; unpack BCD format from 10 bytes to 20 bytes
                    ;    the 10 bytes in bcdstr first is sign
                    ;   Go from byte position 9 to position 0 
                    ;      position ecx=8 is digits d17,d16
                    ;       position ecx=0 is digits d1,d0
                    ;--------------------------------------------

                    UNPACKBCDSTRS4     ; no sign

                    ; -------------------------------
                    ;   ebx= first digit position
                    ; -------------------------------

                    mov     eax, [esp+stk_exponentR4]


                    mov     edx, $DECIMALPLACES_REAL4
                    mov     ebx, 19                     ; 19=offset 20 minus 1
                    sub     ebx, edx
          
                    cmp     byte ptr [esi+ebx], '0'
                    jne     short @F

                    add     ebx, 1              ; next position
                    sub     eax, 1              ; exponent=exponent-1
                    
                    ; -----------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; edx= number of decimal places
                    ; -----------------------------------
            @@:     mov     ecx, 20
                    sub     ecx, ebx     

                    mov     edx, [esp+stk_expscaleR4]
                    add     edx, eax
                         
                    or      eax, eax
                    jns     _ispositive
                    ;
                    mov     ecx, eax                    
                    neg     ecx
                    cmp     ecx, edx
                    jae     _isscientific
                    
                ; 
                ;  Regular notation - negative
                ; 
                    mov     ax, '.0'
                    mov     word ptr [edi], ax
                    add     edi, 2
                    ;
                    sub     ecx, 1
                    jz      short _movedecimal
                    ;
                    sub     edx, ecx
                    ;
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                                        
                    ; -----------------------------
                    ;     edx decimal digits
                    ; -----------------------------
    _movedecimal:   movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;--------------------------------------------------------------------
    _ispositive:    cmp     eax, edx
                    ja      _isscientific
                    
                ; 
                ;  Regular notation - positive
                ; 
                    add     eax, 1              ; number of integer digits
                    sub     ecx, eax            ; number of decimal digits                    

            @@:     movzx   edx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], dl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     eax, 1
                    jnz     short @B

                    or      ecx, ecx
                    jz      _finish
                                        
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;                    
            @@:     movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                    jz      short _removeI
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;...........................................................................                   
                ; 
                ;    Scientific Notation    
                ; 

                    ; -------------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; is >= edx decimal places
                    ; -------------------------------------
    _isscientific:  movzx   ecx, byte ptr [esi+ebx]
                    add     ebx, 1
                    mov     ch, '.'
                    mov     word ptr [edi], cx
                    add     edi, 2
                    ;
                    ; move 
                    ;                   
            @@:     movzx   ecx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], cl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short @B 
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B
                                       
            ;........................................
            @@:     EXPONENTREAL_4R                   

        _finish:    mov      eax, edi
                    mov      edi, [esp+stk_pStrR4]        ; pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8
;-----------------------------------------------------------
    _isinfinityS:   mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    mov      eax, 9
                    jmp      _exit0
                   
                    ;--------------------------
                    ; value to be converted = 0
                    ;--------------------------
        _iszeroS:   mov      word ptr [edi], 3020h
                    mov      eax, 2
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1S:    mov      eax, 1
                    ; -------------------
                    ; Remove sign / space
                    ; -------------------
        _errorS:    add      esp, stk_lenR4
        
                    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2S:    sub      edi, 1
                    fclex
                    mov      eax, 2
                    jmp      _errorS
ConvertFloat4BY     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
;  
; 
; Input:
;           pReal4 = pointer                                dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4DY     proc     pReal4:DWORD, pRcl:DWORD                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      ebx, [esp+16]      ;pReal4
                    mov      edi, [esp+20]      ;pRcl     

                    sub      esp, stk0_lenR4
                    mov      [esp+stk0_pStrR4], edi
                    
                    ; --------------------------
                    ;          examine
                    ; --------------------------
                    EXAMINE1SREAL4
                                  
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATER4
                    fistp    dword ptr [esp+stk0_exponentR4]           
                    fldcw    word ptr [esp+stk0_oldcwR4]

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk0_exponentR4]
                    mov     [esp+stk0_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk0_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   dword ptr [esp+stk0_DWintegerR4]
                    fstsw   ax
                    fwait
                    shr     ax,1
                    jc      _erro2S  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, [esp+stk0_DWintegerR4]
                    mov     eax, dword ptr [esi+0]

                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    
            @@:     lea     esi, [esp+stk0_stringR4+20]

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in BL
                    ; ----------------------------------------
                    CONVERT1EAX                    
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    ; --------------------------
                    ;   Correct the exponent
                    ; --------------------------
                    mov     eax, ebx
                    sub     eax, [esp+stk0_expscaleR4]
                    sub     eax, 1
                    ;mov     [esp+stk0_exponentR4], eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; ecx = exponent
                    ; ------------------------------------------
                    or      eax, eax
                    jns     _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
;-----------------------------------------------------                                        
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;
            ; ebx = total number of digits
            ; eax = exponent
            ;--------------------------------------------------
    _isscientific:  sub     ebx,1
                    ;
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                                        
        _finish:    mov      eax, edi
                    mov      edi, [esp+stk0_pStrR4]   ;pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk0_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8
;-----------------------------------------------------------
    _isinfinityS:   mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    mov      eax, 9
                    jmp      _exit0
                   
                    ;--------------------------
                    ; value to be converted = 0
                    ;--------------------------
        _iszeroS:   mov      word ptr [edi], 3020h
                    mov      eax, 2
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1S:    mov      eax, 1
                    ; -------------------
                    ; Remove sign / space
                    ; -------------------
        _errorS:    add      esp, stk0_lenR4
        
                    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2S:    sub      edi, 1
                    fclex
                    mov      eax, 2
                    jmp      _errorS
ConvertFloat4DY     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 
; 
; Input:
;           pReal4 = pointer                                dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4DX     proc     pReal4:DWORD, pRcl:DWORD                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      ebx, [esp+16]      ;pReal4                    
                    mov      edi, [esp+20]      ;pRcl     

                    sub      esp, stk0_lenR4
                    mov      [esp+stk0_pStrR4], edi

                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------
        _start:     LOG2BASE10_X
                    SETTRUNCATER4                    
                    fistp    dword ptr [esp+stk0_exponentR4]           
                    fldcw    word ptr [esp+stk0_oldcwR4]
                          
                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk0_exponentR4]
                    mov     [esp+stk0_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale                    

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk0_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   dword ptr [esp+stk0_DWintegerR4]
                    fstsw   ax
                    fwait
                    shr     ax,1
                    jc      _erro2  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, [esp+stk0_DWintegerR4]
                    mov     eax, dword ptr [esi+0]

                    mov     bl, ' '
                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    ;
                    mov     bl, '-'
                    
            @@:     mov     byte ptr [edi], bl
                    add     edi, 1

                    lea     esi, [esp+stk0_stringR4+20]

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in BL
                    ; ----------------------------------------
                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    ; --------------------------
                    ;   Correct the exponent
                    ; --------------------------
                    mov     eax, ebx
                    sub     eax, [esp+stk0_expscaleR4]
                    sub     eax, 1
                    ;mov     [esp+stk0_exponentR4], eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; ecx = exponent
                    ; ------------------------------------------
                    or      eax, eax
                    jns     _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

;-----------------------------------------------------                                        
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;
            ; ebx = total number of digits
            ; eax = exponent
            ;--------------------------------------------------
    _isscientific:  sub     ebx,1
                    ;
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                                        
        _finish:    mov      eax, edi
                    mov      edi, [esp+stk0_pStrR4]   ;pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk0_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8                    
;------------------------------------------------------------
;                      fxam, esp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1:     fstp     st(0)
                    mov      eax, 1
                    ;
        _error:     add      esp, stk0_lenR4

                    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2:     fclex
                    mov      eax, 2
                    jmp      _error
ConvertFloat4DX     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 
; Input:
;           pReal4 = pointer                               dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
ConvertFloat4DS     proc     pReal4:DWORD, pRcl:DWORD
                    LOCAL    expscale     :DWORD
                    LOCAL    exponent     :DWORD
                    LOCAL    DWinteger    :DWORD
                    LOCAL    oldcw        :WORD
                    LOCAL    truncw       :WORD
                    LOCAL    string[20]   :BYTE
                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      edi, pRcl     
                    mov      ebx, pReal4

                    ; --------------------------
                    ;          examine
                    ; --------------------------
                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
        _start:     LOG1BASE10_X
                    ; ---------------------------------
                    ; X          in st(2) st(1)
                    ; log10(2)   in st(1) removed fyl2x
                    ; |X|        in st(0) removed fyl2x
                    ; log10(|X|) in st(0) st(0)    
                    ; ---------------------------------                                            

                    ; -----------------------------------------------------------
                    ;       Convert the logarithm to a truncated integer
                    ;       store the truncating value of the logarithm
                    ; -----------------------------------------------------------      
                    SETTRUNCATE oldcw, truncw
                    fistp    exponent
                    fldcw    oldcw          ; load back the former control word

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, exponent
                    mov     expscale, edx
           
                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
            
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    expscale
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   DWinteger
                    fstsw   ax
                    fwait
                    shr     ax,1              ;test for invalid operation
                    jc      _erro2  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, DWinteger
                    mov     eax, dword ptr [esi+0]

                    mov     bl, ' '
                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    ;
                    mov     bl, '-'
                    ; ------------------------
                    ;     Set the sign
                    ; ------------------------
            @@:     mov     byte ptr [edi], bl
                    add     edi, 1
                    
                    lea     esi, string+20

                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4
                    
                    ; -----------------------------------
                    ;     Recalculate exponent based
                    ; in the number of integer digits ebx
                    ; -----------------------------------
                    mov     eax, ebx
                    sub     eax, expscale
                    sub     eax, 1
                    ;mov     exponent, eax
                    
                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; eax = exponent
                    ; ------------------------------------------
                
                    or      eax, eax
                    jns     short _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

            ;--------------------------------------------------
            ; ebx = total number of digits
            ; edx = number of decimal places
            ; eax = exponent
            ;--------------------------------------------------
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                                   
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;--------------------------------------------------
    _isscientific:  sub     ebx, 1
                    
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                            
        _finish:    mov      eax, edi
                    mov      edi, pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret
;------------------------------------------------------------
;                      fxam, ebp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1:     fstp     st(0)
                    mov      eax, 1
                    ;
        _error:     mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2:     fclex
                    mov      eax, 2
                    jmp      _error
ConvertFloat4DS     endp
; 
comment * -----------------------------------------------------------------
          . ConvertFloat4BW
          . Doesnt preserve the FPU registers          
          . Preserves registers EBX, ESI and EDI          
          . Updated March 2013
          ---------------------------------------------------------------- *
; 
ConvertFloat4BW     proc     pReal4:DWORD, pRcl:DWORD 
                    LOCAL    unpacked[20]     :BYTE
                    LOCAL    expscale         :DWORD
                    LOCAL    exponent         :DWORD
                    LOCAL    decimal          :DWORD
                    LOCAL    oldcw            :WORD
                    LOCAL    truncw           :WORD
                    LOCAL    bcdstr[10]       :BYTE
                    LOCAL    content[108]     :BYTE
                    
                    push     ebx
                    push     esi
                    push     edi

                    fsave    content

                    mov      ebx, pReal4                    
                    mov      edi, pRcl
                          
                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------      
        _start:     
                    ;--------------------------------------
                    ;           get the exponent
                    ; exponent = characteristic of log10(X)
                    ;--------------------------------------
                    LOG2BASE10_X
                    SETTRUNCATE oldcw, truncw
                    fistp    exponent
                    fldcw    word ptr oldcw

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, exponent
                    mov     expscale, edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx
                    jns     short _cmpexpscale                     

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    expscale
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]                    
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ;-------------------------------------------------------------
                    ; fbstp rounds the value in ST(0) to the nearest integer 
                    ;-------------------------------------------------------------
                    fbstp    tbyte ptr bcdstr
                    fstsw    ax
                    fwait
                    shr      ax,1
                    jc       _erro2  

                    ;--------------------------------------------
                    ; unpack BCD format from 10 bytes to 20 bytes
                    ;    the 10 bytes in bcdstr first is sign
                    ;   Go from byte position 9 to position 0 
                    ;      position ecx=8 is digits d17,d16
                    ;       position ecx=0 is digits d1,d0
                    ;--------------------------------------------
                    UNPACKBCDSTRING
                    
                    ; -------------------------------
                    ;   ebx= first digit position
                    ; -------------------------------
                    mov     eax, exponent

                    mov     edx, $DECIMALPLACES_REAL4
                    mov     ebx, 19                     ; 19=offset 20 minus 1
                    sub     ebx, edx
          
                    cmp     byte ptr [esi+ebx], '0'
                    jne     short @F

                    add     ebx, 1              ; next position
                    sub     eax, 1              ; exponent=exponent-1
                    
                    ; -----------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; edx= number of decimal places                    
                    ; -----------------------------------
            @@:     mov     ecx, 20
                    sub     ecx, ebx     

                    mov     edx, expscale
                    add     edx, eax

                    or      eax, eax
                    jns     _ispositive
                    ;
                    mov     ecx, eax                    
                    neg     ecx
                    cmp     ecx, edx
                    jae     _isscientific
                    
                ; 
                ;  Regular notation - negative
                ; 
                    mov     ax, '.0'
                    mov     word ptr [edi], ax
                    add     edi, 2
                    ;
                    sub     ecx, 1
                    jz      short _movedecimal
                    ;
                    sub     edx, ecx
                    ;
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                                        
                    ; -----------------------------
                    ;     edx decimal digits
                    ; -----------------------------
    _movedecimal:   movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;--------------------------------------------------------------------
    _ispositive:    cmp     eax, edx
                    ja      _isscientific
                    
                ; 
                ;  Regular notation - positive
                ; 
                    add     eax, 1              ; number of integer digits
                    sub     ecx, eax            ; number of decimal digits                    

            @@:     movzx   edx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], dl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     eax, 1
                    jnz     short @B

                    or      ecx, ecx
                    jz      _finish
                                        
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;                    
            @@:     movzx   eax, byte ptr [esi+ebx]
                    mov     byte ptr [edi], al
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     ecx, 1
                    jnz     short @B
                    jz      short _removeI
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jne     _finish
;...........................................................................                   
                ; 
                ;    Scientific Notation    
                ; 

                    ; -------------------------------------
                    ; eax= exponent
                    ; ecx= number of digits in the buffer
                    ; is >= edx decimal places
                    ; -------------------------------------
    _isscientific:  movzx   ecx, byte ptr [esi+ebx]
                    add     ebx, 1
                    mov     ch, '.'
                    mov     word ptr [edi], cx
                    add     edi, 2
                    ;
                    ; move 
                    ;                   
            @@:     movzx   ecx, byte ptr [esi+ebx]
                    mov     byte ptr [edi], cl
                    add     ebx, 1
                    add     edi, 1
                    ;
                    sub     edx, 1
                    jnz     short @B 
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B
                   
            ;........................................
            @@:     EXPONENTREAL_4R                   

        _finish:    mov      eax, edi
                    mov      edi, pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    frstor   content
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret
;------------------------------------------------------------
;                      fxam, ebp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0

        _erro1:     fstp     st(0)
                    mov      eax, 1
                    
        _error:     mov      dword ptr [edi], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    mov      byte ptr [edi+5], 0
                    mov      dword ptr [edi-4], 5
                    ;
                    frstor   content
                    stc                    
                    jmp      _exit
                    
        _erro2:     fclex
                    mov      eax, 2
                    jmp     _error
ConvertFloat4BW     endp
; 
; 
; Input:
;           pReal4 = pointer                                dd 0    <------- for lenght
;           pRcl   --------------> buffer shoud be  _buffer db x dup (?), 0
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4DW     proc     pReal4:DWORD, pRcl:DWORD                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    mov      ebx, [esp+16]      ;pReal4                    
                    mov      edi, [esp+20]      ;pRcl
                    sub      esp, stk01_lenR4
                    
                    mov      [esp+stk0_pStrR4], edi
                    
                    fsave    [esp+stk0_contentR4]

                    fld      dword ptr [ebx]
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                    
                    ; ---------------
                    ; Is demormalized
                    ; ---------------
    _isDenormal:    ;lea      ebx, [esp+stk0_RealBufR8]
                    ;fstp     dword ptr [ebx]
                    ;or       dword ptr [ebx], 800000H
                    ;fld      dword ptr [ebx]
                        
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------
        _start:     LOG2BASE10_X
                    SETTRUNCATER4                    
                    fistp    dword ptr [esp+stk0_exponentR4]           
                    fldcw    word ptr [esp+stk0_oldcwR4]

                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk0_exponentR4]
                    mov     [esp+stk0_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale                    

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk0_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   dword ptr [esp+stk0_DWintegerR4]
                    fstsw   ax
                    fwait
                    shr     ax,1
                    jc      _erro2  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, [esp+stk0_DWintegerR4]
                    mov     eax, dword ptr [esi+0]

                    mov     bl, ' '
                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    ;
                    mov     bl, '-'
                    
            @@:     mov     byte ptr [edi], bl
                    add     edi, 1

                    lea     esi, [esp+stk0_stringR4+20]

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in BL
                    ; ----------------------------------------
                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    ; --------------------------
                    ;   Correct the exponent
                    ; --------------------------
                    mov     eax, ebx
                    sub     eax, [esp+stk0_expscaleR4]
                    sub     eax, 1
                    ;mov     [esp+stk0_exponentR4], eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; ecx = exponent
                    ; ------------------------------------------
                    or      eax, eax
                    jns     _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2

                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

;-----------------------------------------------------                                        
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

            ;--------------------------------------------------
            ;                 is Scientific
            ;
            ; ebx = total number of digits
            ; eax = exponent
            ;--------------------------------------------------
    _isscientific:  sub     ebx,1
                    ;
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                                        
        _finish:    mov      eax, edi
                    mov      edi, [esp+stk0_pStrR4]   ;pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    frstor   [esp+stk0_contentR4]

                    add      esp, stk01_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8                    
;------------------------------------------------------------
;                      fxam, esp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1:     fstp     st(0)
                    mov      eax, 1
                    ;
        _error:     frstor   [esp+stk0_contentR4]
        
                    add      esp, stk01_lenR4

                    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0

                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2:     fclex
                    mov      eax, 2
                    jmp      _error
ConvertFloat4DW     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 
; Input:
;           Real4 = real4 value
;
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
ConvertFloat4DZ     proc     iReal4:DWORD, pRcl:DWORD                                       
                    push     ebx
                    push     esi
                    push     edi                    
                    
                    fld      dword ptr [esp+16]
                    
                    mov      edi, [esp+20]      ;pRcl                    
                    sub      esp, stk0_lenR4
                    mov      [esp+stk0_pStrR4], edi
                    ;
                    fxam
                    fstsw    ax                
                    fwait
                    sahf
                    jz       short @F
                    jpo      _erro1          ;C3=0 and C2=0 would be NAN or unsupported
                    jnc      short _start

                    ;-------------
                    ; is  INFINITY
                    ;-------------                   
                    mov      al,"+"
                    test     ah, 2             ;C1 field = sign
                    jz       _isinfinity
                    mov      al,"-"
                    jnz      _isinfinity
                                      
                    ;--------------------------
                    ; may be 0  or Denormalized
                    ;--------------------------
            @@:     jpo      _iszero    
                                                                                                                  
                    ;----------------------------------------
                    ; the exponent is the integer of log10(X)
                    ;
                    ;   log10(X)= log10(2) * log2(X)
                    ;
                    ;     If X = 2^(c+m) => log2(X)= c+m
                    ;         where c is an integer
                    ;
                    ; fxtract gives the c in st(1) and not m
                    ;  replacing log2(X) by c taking m~=0
                    ; we have 
                    ;
                    ;        log10(X)= log10(2) * c
                    ;
                    ; we get the integer part with
                    ;                    
                    ;        fistp    exponent
                    ;----------------------------------------
        _start:     LOG2BASE10_X        
                    SETTRUNCATER4                    
                    fistp    dword ptr [esp+stk0_exponentR4]           
                    fldcw    word ptr [esp+stk0_oldcwR4]
                          
                    ; -------------------------
                    ; Get exponent scale factor
                    ; expscale = dp - exponent                    
                    ; -------------------------
                    mov     eax, $EXPONENT_REAL4_MAX                    
                    mov     edx, $DECIMALPLACES_REAL4
                    sub     edx, [esp+stk0_exponentR4]
                    mov     [esp+stk0_expscaleR4], edx

                    mov     ebx, offset _PowerTblDQP38
        
                    or      edx, edx 
                    jns     short _cmpexpscale                    

                    neg     edx
                    mov     ebx, offset _PowerTblDQM38
                    
                    cmp     edx, 46
                    jbe     short _load0

                    ; ------------------------------------------------
                    ;               compute 10^expscale
                    ; ------------------------------------------------
    _power10:       fild    dword ptr [esp+stk0_expscaleR4]
                    fldl2t             ; log2(10)
                    fmul               ; log2(10)*expscale
                    fld     st
                    frndint            ; get the characteristic
                    fxch
                    fsub    st,st(1)   ; get only the mantissa but keep the characteristic
                    f2xm1              ; 2^(mantissa)-1
                    fld1
                    fadd               ; add 1 and pop
                    fscale
                    fstp    st(1)      ; remove the characteristic
                    jmp     _multiply

    _cmpexpscale:   cmp     edx, 46
                    ja      short _power10
            
        _load0:     fld     qword ptr [ebx+edx*8]
                    
                    ; -------------------------                    
                    ; Multiply X by 10^expscale
                    ; -------------------------
    _multiply:      fmul

                    ; -----------------
                    ; store the integer
                    ; -----------------
                    fistp   dword ptr [esp+stk0_DWintegerR4]
                    fstsw   ax
                    fwait
                    shr     ax,1
                    jc      _erro2  

                    ; -------------------------
                    ; convert integer to string
                    ; -------------------------
                    lea     esi, [esp+stk0_DWintegerR4]
                    mov     eax, dword ptr [esi+0]

                    mov     bl, ' '
                    or      eax, eax
                    jns     short @F
                    
                    neg     eax
                    ;
                    mov     bl, '-'
                    
            @@:     mov     byte ptr [edi], bl
                    add     edi, 1

                    lea     esi, [esp+stk0_stringR4+20]

                    ; ----------------------------------------
                    ; Divide EAX by 10 and get the digit in BL
                    ; ----------------------------------------
                    CONVERT1EAX
                    
                    mov     edx, $DECIMALPLACES_REAL4

                    ; --------------------------
                    ;   Correct the exponent
                    ; --------------------------
                    mov     eax, ebx
                    sub     eax, [esp+stk0_expscaleR4]
                    sub     eax, 1
                    ;mov     [esp+stk0_exponentR4], eax

                    ; ------------------------------------------
                    ; Regular notation or scientific notation ?
                    ; ebx = total number of digits in the buffer
                    ; edx = number of decimal places
                    ; ecx = exponent
                    ; ------------------------------------------
                    or      eax, eax
                    jns     _ispositive       ; exponent is positive

                    mov     ecx, eax
                    neg     ecx

                    ;cmp     ecx, 3  
                    cmp     ecx, edx
                    ja      _isscientific

                    ; --------------------------
                    ; Regular notation - decimal
                    ; --------------------------
                    mov     word ptr [edi], '.0'
                    add     edi, 2
                    
                    ; ------------------------------
                    ; If exponent = -1 it is 0.ddddd
                    ; If exponent = -2 it is 0.0dddd
                    ;         and so on
                    ; ------------------------------
                    sub     ecx, 1
                    jz      _movedecimal
                    
                    sub     edx, ecx
                    
                    ; -------------------------
                    ;        insert 0
                    ; -------------------------
            @@:     mov     byte ptr [edi], '0'
                    add     edi, 1
                    sub     ecx, 1
                    jnz     short @B

    _movedecimal:   movzx   eax, byte ptr [esi]
                    mov     byte ptr [edi], al
                    add     edi, 1
                    add     esi, 1

                    sub     edx, 1
                    jnz     short _movedecimal
                    jz      short _removeD
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeD:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish

;-----------------------------------------------------                                        
                    ; -------------------
                    ;   exponent >= 0
                    ; -------------------
    _ispositive:    cmp     eax, edx
                    jae     _isscientific
                
                    ; --------------------------
                    ; Regular notation - integer
                    ; --------------------------
                    add     eax, 1              ; number of integer digits
                    sub     ebx, eax            ; number of decimal digits
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     eax, 1
                    jnz     short @B
                    ;
                    or      ebx, ebx
                    jz      _finish
                    
                    mov     byte ptr [edi], '.'
                    add     edi, 1
                    ;
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    add     edi, 1
                    add     esi, 1                    

                    sub     ebx, 1
                    jnz     short @B
                    jmp     short _removeI
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeI:   movzx   eax, word ptr [edi-2]
                    cmp     al, '.'
                    je      _finish
                    ;
                    cmp     ah, '0'
                    je      short @B
                    jmp     _finish
                                        
            ;--------------------------------------------------
            ;                 is Scientific
            ;
            ; ebx = total number of digits
            ; eax = exponent
            ;--------------------------------------------------
    _isscientific:  sub     ebx,1
                    ;
                    movzx   edx, byte ptr [esi]
                    mov     dh, '.'                    
                    add     esi, 1
                    ;
                    mov     word ptr [edi], dx
                    add     edi, 2
                    
            @@:     movzx   edx, byte ptr [esi]
                    mov     byte ptr [edi], dl
                    ;
                    add     edi, 1
                    add     esi, 1

                    sub     ebx, 1
                    jnz     short @B
                    jz      short _removeE
                    
                    ; ------------------
                    ; remove last zeroes
                    ; ------------------
            @@:     sub     edi, 1
        _removeE:   movzx   edx, word ptr [edi-2]
                    cmp     dl, '.'
                    je      short @F
                    ;
                    cmp     dh, '0'
                    je      short @B

            @@:     EXPONENTREAL_4R
                                        
        _finish:    mov      eax, edi
                    mov      edi, [esp+stk0_pStrR4]   ;pRcl
                    sub      eax, edi

        _exit0:     mov      dword ptr [edi-4], eax
                    mov      byte ptr [edi+eax], 0

                    add      esp, stk0_lenR4
                                              
                    xor      eax, eax
                    clc
        _exit:      pop      edi
                    pop      esi
                    pop      ebx
                    ret      8                    
;------------------------------------------------------------
;                      fxam, esp
;------------------------------------------------------------
    _iszero:        fstp     st(0)                                      
                    mov      word ptr [edi], '0 '   ;3020h
                    mov      eax, 2
                    jmp      _exit0
            
    _isinfinity:    fstp     st(0)
                    mov      byte ptr [edi], al
                    mov      dword ptr [edi+1], "IFNI"
                    mov      dword ptr [edi+5], "YTIN"
                    ;
                    mov      eax, 9
                    jmp      _exit0
                    
                    ; --------------------
                    ; is indefinite or NAN
                    ; --------------------
        _erro1:     fstp     st(0)
                    mov      eax, 1
                    ;
        _error:     add      esp, stk0_lenR4

                    mov      dword ptr [edi+0], "ORRE"
                    mov      byte ptr [edi+4], "R"
                    ;
                    mov      dword ptr [edi-4], 5
                    mov      byte ptr [edi+5], 0
                    stc
                    jmp      _exit
                                        
                    ; -----------------
                    ; invalid operation
                    ; -----------------
        _erro2:     fclex
                    mov      eax, 2
                    jmp      _error
ConvertFloat4DZ     endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
; 
